3v4l.org

run code in 150+ php & hhvm versions
Bugs & Features
<?php echo 'a'; class MyException extends Exception{ public function __construct($message, $code = 0, Exception $previous = null) { // some code // make sure everything is assigned properly parent::__construct($message, $code, $previous); } // custom string representation of object public function __toString() { return __CLASS__ . ": [{$this->code}]: {$this->message}\n"; } public function customFunction() { echo "A custom function for this type of exception\n"; } } class TestException { public $var; const THROW_NONE = 0; const THROW_CUSTOM = 1; const THROW_DEFAULT = 2; function __construct($avalue = self::THROW_NONE) { switch ($avalue) { case self::THROW_CUSTOM: // throw custom exception throw new MyException('1 is an invalid parameter', 5); break; case self::THROW_DEFAULT: // throw default one. throw new Exception('2 is not allowed as a parameter', 6); break; default: // No exception, object will be created. $this->var = $avalue; break; } } } try { $o = new TestException(TestException::THROW_CUSTOM); } catch (MyException $e) { // Will be caught echo "Caught my exception\n", $e; $e->customFunction(); } catch (Exception $e) { // Skipped echo "Caught Default Exception\n", $e; } // Continue execution var_dump($o); // Null echo "\n\n"; // Example 2 try { $o = new TestException(TestException::THROW_DEFAULT); } catch (MyException $e) { // Doesn't match this type echo "Caught my exception\n", $e; $e->customFunction(); } catch (Exception $e) { // Will be caught echo "Caught Default Exception\n", $e; } // Continue execution var_dump($o); // Null echo "\n\n"; try { $o = new TestException(TestException::THROW_CUSTOM); } catch (Exception $e) { // Will be caught echo "Default Exception caught\n", $e; } // Continue execution var_dump($o); // Null echo "\n\n"; try { $o = new TestException(); } catch (Exception $e) { // Skipped, no exception echo "Default Exception caught\n", $e; } // Continue execution var_dump($o); // TestException echo "p\n\n"; ?>
Output for 7.0.0 - 7.1.0
aCaught my exception MyException: [5]: 1 is an invalid parameter A custom function for this type of exception Notice: Undefined variable: o in /in/XfDfH on line 58 NULL Caught Default Exception Exception: 2 is not allowed as a parameter in /in/XfDfH:38 Stack trace: #0 /in/XfDfH(64): TestException->__construct(2) #1 {main} Notice: Undefined variable: o in /in/XfDfH on line 73 NULL Default Exception caught MyException: [5]: 1 is an invalid parameter Notice: Undefined variable: o in /in/XfDfH on line 82 NULL object(TestException)#3 (1) { ["var"]=> int(0) } p
Output for hhvm-3.10.0 - 3.12.0
aCaught my exception MyException: [5]: 1 is an invalid parameter A custom function for this type of exception Notice: Undefined variable: o in /in/XfDfH on line 58 NULL Caught Default Exception exception 'Exception' with message '2 is not allowed as a parameter' in /in/XfDfH:38 Stack trace: #0 /in/XfDfH(64): TestException->__construct() #1 {main} Notice: Undefined variable: o in /in/XfDfH on line 73 NULL Default Exception caught MyException: [5]: 1 is an invalid parameter Notice: Undefined variable: o in /in/XfDfH on line 82 NULL object(TestException)#7 (1) { ["var"]=> int(0) } p
Output for 5.5.0 - 5.6.28
aCaught my exception MyException: [5]: 1 is an invalid parameter A custom function for this type of exception Notice: Undefined variable: o in /in/XfDfH on line 58 NULL Caught Default Exception exception 'Exception' with message '2 is not allowed as a parameter' in /in/XfDfH:38 Stack trace: #0 /in/XfDfH(64): TestException->__construct(2) #1 {main} Notice: Undefined variable: o in /in/XfDfH on line 73 NULL Default Exception caught MyException: [5]: 1 is an invalid parameter Notice: Undefined variable: o in /in/XfDfH on line 82 NULL object(TestException)#3 (1) { ["var"]=> int(0) } p
Output for 5.3.0 - 5.4.45
aCaught my exception MyException: [5]: 1 is an invalid parameter A custom function for this type of exception NULL Caught Default Exception exception 'Exception' with message '2 is not allowed as a parameter' in /in/XfDfH:38 Stack trace: #0 /in/XfDfH(64): TestException->__construct(2) #1 {main}NULL Default Exception caught MyException: [5]: 1 is an invalid parameter NULL object(TestException)#3 (1) { ["var"]=> int(0) } p
Output for 5.2.3 - 5.2.17
a Fatal error: Wrong parameters for Exception([string $exception [, long $code ]]) in /in/XfDfH on line 8
Process exited with code 255.
Output for 5.1.2 - 5.2.2
a<br /> <b>Fatal error</b>: Wrong parameters for Exception([string $exception [, long $code ]]) in <b>/in/XfDfH</b> on line <b>8</b><br />
Process exited with code 255.
Output for 5.1.0 - 5.1.1
a<br /> <b>Fatal error</b>: Wrong parameter count for exception([string $exception [, long $code ]]) in <b>/in/XfDfH</b> on line <b>8</b><br />
Process exited with code 255.
Output for 5.0.0 - 5.0.5
a<br /> <b>Fatal error</b>: Argument 3 must not be null in <b>/in/XfDfH</b> on line <b>4</b><br />
Process exited with code 255.
Output for 4.4.2 - 4.4.9
<br /> <b>Parse error</b>: syntax error, unexpected T_STRING, expecting T_OLD_FUNCTION or T_FUNCTION or T_VAR or '}' in <b>/in/XfDfH</b> on line <b>4</b><br />
Process exited with code 255.
Output for 4.3.0 - 4.3.1, 4.3.5 - 4.4.1
<br /> <b>Parse error</b>: parse error, unexpected T_STRING, expecting T_OLD_FUNCTION or T_FUNCTION or T_VAR or '}' in <b>/in/XfDfH</b> on line <b>4</b><br />
Process exited with code 255.
Output for 4.3.2 - 4.3.4
<br /> <b>Parse error</b>: parse error, expecting `T_OLD_FUNCTION' or `T_FUNCTION' or `T_VAR' or `'}'' in <b>/in/XfDfH</b> on line <b>4</b><br />
Process exited with code 255.